* Turbo patch (Assembly version)
*
* This Patch allows Turbo programs to run with SV.BASE in any place
* Should be used with the Turbo patch linker (_BAS)
*
* v0.02 The problems of Turbo programs which for a strange bug
*       access location $0000000 should be fixed now.
*       Now they should work happily also on the Atari TT with QVME
*
*
* by Davide Santachiara - Via De Marchi 2 - 42100 Reggio Emilia - Italy
*
*                       v0.01   03 Feb 1994
*                       v0.02   10 Jul 1994
*
*       QMAC/GST version

        SECTION code

start
        bra.s   skip

        dc.l    '5.10'
        dc.w    $4afb
jobname
        dc.w    0
        ds.b    12

skip
        movem.l d0-d2/a0/a3,-(a7)
        lea     patch_end,a3
        moveq   #0,d0
        trap    #1

        adda.l  #$10,a0
        move.l  a0,$b0(a3)
        move.l  a0,$114(a3)
        move.w  #$4e71,100(a3)  ; nop

        movem.l (a7)+,d0-d2/a0/a3
        adda.l  a6,a4
        adda.l  #patch_end-start,a6
        bra.s   patch_end

tt_check
        cmpa.l   #0,a2          ; checks if A2 is 0 to avoid
        beq.s   no_peek         ; reading that location
        move.w  (a2),d4
        movea.l a0,a3
        rts
no_peek
        move.w  #$4c02,d0       ; Simulates to read Minerva $0 !
        movea.l a0,a3
        rts

tt_patch_addr
        dc.w    tt_check-start

patch_end

        end
